import java.net.*;
import java.awt.*;
import java.awt.event.*;
import javax.swing.ImageIcon;
public class zobrazeni extends Canvas implements MouseWheelListener,MouseMotionListener
{
    private Obec[] obc = IO.getRozcestniky();
    private boolean zobraz=true;
    private Image[][] i = new Image[5][5];
    public int x;
    public int y;
    public int z;
    public int minulyZ;
    private int posunX;
    private int posunY;
    public zobrazeni(){
        addMouseMotionListener(this);
    }
    public static Image getObrazek(int x,int y,int z){
        try{
            System.out.println("x: "+(int)(x/256/(z+1))+" y: "+(int)(y/256/(z+1))+" z: "+z);
            URL url = new URL("http://192.168.2.76:80/"+z+"/"+(int)(x/256/(z+1))+"/"+(int)(y/256/(z+1))+".jpg");
            return new ImageIcon(url).getImage();
        }catch(Exception e){
            return null;
        }
    }
    public void zobrazRozcestniky(boolean z){
        zobraz=z;
    }
    public void posun(int x,int y,int z){
        this.x=x;
        this.y=y;
        this.z=z;
        for(int a=-1;a<4;a++)
            for(int b=-1;b<4;b++){
                long cas=System.currentTimeMillis();
                i[a+1][b+1]=getObrazek(x+a*256*(z+1),y+b*256*(z+1),z);
                //System.out.println(System.currentTimeMillis()-cas);
            }
        System.out.println("=============================");
    }
    public void paint(Graphics g){
        g.setColor(Color.BLACK);
        g.translate(posunX,posunY);
        for(int a=-1;a<4;a++)
            for(int b=-1;b<4;b++)
                g.drawImage(i[a+1][b+1],256*a,256*b,null);
        /*if(zobraz)
            for(Obec obce:obc)
                g.fillOval((x-obce.x)/(z+1)-15,(y-obce.y)/(z+1)-15,30,30);*/
    }
    public void mouseWheelMoved(MouseWheelEvent e){
        double Z=z;
        z-=(int)Math.signum(e.getWheelRotation());
        System.out.println(Z-z);
        posun((int)(x*(z>Z?2:(double)1/2)),(int)(y*(z>Z?2:(double)1/2)),z);
    }
    public void mouseMoved(MouseEvent e){}
    public void mouseDragged(MouseEvent e){
        posunX-=(int)Math.signum(e.getX()-384);
        posunY-=(int)Math.signum(e.getY()-384);
        if(Math.abs(posunX)>256||Math.abs(posunY)>256){
            posun(x-posunX*(z+1),y-posunY*(z+1),z);
            posunX=0;
            posunY=0;
        }
    }
}
